#
# spec file for package gtk2 (Version 2.2.3)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  atk atk-devel expat freetype2 freetype2-devel glib2 glib2-devel gnome-filesystem libjpeg libpng-devel-packages libtiff pango pango-devel pkgconfig x-devel-packages
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs atk atk-devel autoconf automake binutils cracklib expat fontconfig fontconfig-devel freetype2 freetype2-devel gcc gdbm gettext glib2 glib2-devel gnome-filesystem libjpeg libpng libpng-devel libtiff libtool pango pango-devel perl pkgconfig rpm

Name:         gtk2
%define prefix /opt/gnome
%define sysconfdir /etc%prefix
License:      LGPL
Group:        System/Libraries
Provides:     gtk2+ 
Autoreqprov:  on
Requires:     gnome-filesystem
Version:      2.2.3
Release:      57
Summary:      Library for Creation of Graphical User Interfaces
Source:       gtk+-%{version}.tar.bz2
Source1:      SuSEconfig.gtk2
Patch:        gtk+-%{version}-autoconf.patch
Patch1:       gtk-socket-focus.patch
Patch2:       gtk-xpm-secfix.dif
Patch3:       ico.diff
Patch23:      xpm-overflow.patch
Patch24:      gdk-pixbuf-loop.diff
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
This fast and versatile library is used all over the world for all
GNOME applications, the GIMP, and several others. Originally it was
written for the GIMP and hence has the name Gimp ToolKit. Many people
like it because it is small, efficient, and very configurable.



Authors:
--------
    Peter Mattis <petm@xcf.berkeley.edu>
    Spencer Kimball <spencer@xcf.berkeley.edu>
    Josh MacDonald <jmacd@xcf.berkeley.edu>
    Shawn T. Amundson <amundson@gtk.org>
    Jerome Bolliet <bolliet@gtk.org>
    Damon Chaplin <damon@gtk.org>
    Tony Gale <gale@gtk.org>
    Jeff Garzik <jgarzik@gtk.org>
    Lars Hamann <lars@gtk.org>
    Raja R Harinath <harinath@gtk.org>
    Carsten Haitzler <raster@gtk.org>
    Tim Janik <timj@gtk.org>
    Stefan Jeske <stefan@gtk.org>
    Elliot Lee <sopwith@gtk.org>
    Raph Levien <raph@gtk.org>
    Ian Main <imain@gtk.org>
    Federico Mena <quartic@gtk.org>
    Paolo Molaro <lupus@gtk.org>
    Jay Painter <jpaint@gtk.org>
    Manish Singh <manish@gtk.org>
    Owen Taylor <otaylor@gtk.org>

%package devel
Summary:      Library for creation of graphical user interfaces
Group:        Development/Libraries/X11
Autoreqprov:  on
Requires:     %{name} = %{version}
Requires:     glib2-devel pango-devel atk-devel

%description devel
This fast and versatile library is used all over the world for all
GNOME applications, the GIMP and several others. Originally it was
written for the GIMP and hence has the name Gimp ToolKit. Many people
like it because it is small, efficient and very configurable.



Authors:
--------
    Peter Mattis <petm@xcf.berkeley.edu>
    Spencer Kimball <spencer@xcf.berkeley.edu>
    Josh MacDonald <jmacd@xcf.berkeley.edu>
    Shawn T. Amundson <amundson@gtk.org>
    Jerome Bolliet <bolliet@gtk.org>
    Damon Chaplin <damon@gtk.org>
    Tony Gale <gale@gtk.org>
    Jeff Garzik <jgarzik@gtk.org>
    Lars Hamann <lars@gtk.org>
    Raja R Harinath <harinath@gtk.org>
    Carsten Haitzler <raster@gtk.org>
    Tim Janik <timj@gtk.org>
    Stefan Jeske <stefan@gtk.org>
    Elliot Lee <sopwith@gtk.org>
    Raph Levien <raph@gtk.org>
    Ian Main <imain@gtk.org>
    Federico Mena <quartic@gtk.org>
    Paolo Molaro <lupus@gtk.org>
    Jay Painter <jpaint@gtk.org>
    Manish Singh <manish@gtk.org>
    Owen Taylor <otaylor@gtk.org>

%package doc
Summary:      Library for creation of graphical user interfaces
Group:        Development/Libraries/X11
Requires:     %{name} = %{version}

%description doc
This fast and versatile library is used all over the world for all
GNOME applications, the GIMP and several others. Originally it was
written for the GIMP and hence has the name Gimp ToolKit. Many people
like it because it is small, efficient and very configurable.



Authors:
--------
    Peter Mattis <petm@xcf.berkeley.edu>
    Spencer Kimball <spencer@xcf.berkeley.edu>
    Josh MacDonald <jmacd@xcf.berkeley.edu>
    Shawn T. Amundson <amundson@gtk.org>
    Jerome Bolliet <bolliet@gtk.org>
    Damon Chaplin <damon@gtk.org>
    Tony Gale <gale@gtk.org>
    Jeff Garzik <jgarzik@gtk.org>
    Lars Hamann <lars@gtk.org>
    Raja R Harinath <harinath@gtk.org>
    Carsten Haitzler <raster@gtk.org>
    Tim Janik <timj@gtk.org>
    Stefan Jeske <stefan@gtk.org>
    Elliot Lee <sopwith@gtk.org>
    Raph Levien <raph@gtk.org>
    Ian Main <imain@gtk.org>
    Federico Mena <quartic@gtk.org>
    Paolo Molaro <lupus@gtk.org>
    Jay Painter <jpaint@gtk.org>
    Manish Singh <manish@gtk.org>
    Owen Taylor <otaylor@gtk.org>

%prep
%setup -q -n gtk+-%{version} 
%patch -p1
%patch1
cd gdk-pixbuf
%patch2 
%patch3
%patch23
cd ..
%patch24 -p1

%build
%{?suse_update_config:%{suse_update_config -f}}
libtoolize --force
aclocal -I m4macros
autoconf 
%ifarch ppc64
export CFLAGS="$RPM_OPT_FLAGS -mminimal-toc"
%else
export CFLAGS="$RPM_OPT_FLAGS"
%endif
./configure --prefix=%{prefix} \
	    --libdir=%{prefix}/%_lib \
	    --with-native-locale=yes \
	    --with-xinput=xfree \
	    --mandir=%{prefix}/man \
	    --infodir=%{prefix}/info \
	    --sysconfdir=%{sysconfdir} \
	    --enable-shm \
	    --enable-xim \
	    --enable-fbmanager \
	    --with-gdktarget=x11
export LIBRARY_PATH=/usr/%_lib/glib2:%{prefix}/%_lib/glib2
make

%install
rm -rf $RPM_BUILD_ROOT
export LIBRARY_PATH=$RPM_BUILD_ROOT/usr/%_lib:$RPM_BUILD_ROOT/usr/%_lib/gtk-2.0/%{version}/loaders:$RPM_BUILD_ROOT/usr/%_lib/gtk-2.0/%{version}
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin/conf.d
mkdir -p $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0
install -m 755 $RPM_SOURCE_DIR/SuSEconfig.gtk2 $RPM_BUILD_ROOT/sbin/conf.d
touch $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gtk.immodules $RPM_BUILD_ROOT%{sysconfdir}/gtk-2.0/gdk-pixbuf.loaders
mkdir -p $RPM_BUILD_ROOT%{prefix}/%_lib/gtk-2.0/modules
mkdir -p $RPM_BUILD_ROOT%{prefix}/%_lib/gtk-2.0/immodules
mkdir -p $RPM_BUILD_ROOT%{prefix}/%_lib/gtk-2.0/2.2.0/engines
%find_lang gtk20

%clean
rm -rf $RPM_BUILD_ROOT

%post
touch var/adm/SuSEconfig/run-gtk

%files -f %files -f gtk20.lang
%doc AUTHORS COPYING README NEWS ChangeLog 
%{prefix}/bin/*query*
%{prefix}/%_lib/lib*.so.*
%dir %{prefix}/%_lib/gtk-2.0
%dir %{prefix}/%_lib/gtk-2.0/[2me]*
%dir %{prefix}/%_lib/gtk-2.0/immodules
%dir %{prefix}/%_lib/gtk-2.0/2*/*
%{prefix}/%_lib/gtk-2.0/2*/*/*.so
%{prefix}/share/themes/*
%dir %{sysconfdir}/gtk-2.0
%ghost %{sysconfdir}/gtk-2.0/gtk.immodules
%ghost %{sysconfdir}/gtk-2.0/gdk-pixbuf.loaders
/sbin/conf.d/SuSEconfig.gtk2

%files devel
%{prefix}/bin/*-demo
%{prefix}/bin/*-csource
%{prefix}/include/gtk-2.0
%{prefix}/%_lib/lib*.so
%{prefix}/%_lib/lib*a
%{prefix}/%_lib/gtk-2.0/2*/*/*.la
%{prefix}/%_lib/gtk-2.0/include
%{prefix}/%_lib/pkgconfig/*.pc
%{prefix}/share/gtk-2.0
%{prefix}/share/aclocal/*.m4
%doc %{prefix}/man/man*/*

%files doc
%{prefix}/share/gtk-doc/html/*

%changelog -n gtk2
* Mon Oct 31 2005 - nadvornik@suse.cz
- More XPM fixes: CVE-2005-2975 xpm too many colors DoS (#129642)
* Thu Oct 20 2005 - sbrabec@suse.cz
- Fixed XPM buffer overflow vulnerability (#129642).
* Tue Aug 24 2004 - hhetter@suse.de
- added patches for
  CAN-2004-0782 Heap-based overflow in pixbuf_create_from_xpm
  CAN-2004-0783 Stack-based overflow in xpm_extract_color
  CAN-2004-0788 ico loader integer overflow.
  (SUSE Bug Id#44100)
* Tue Jan 06 2004 - sbrabec@suse.cz
- Fixed focus loop in gtk_socket_focus() (#33810).
  Fixes 100%% CPU load problem in Notification Area Applet.
  http://bugzilla.gnome.org/show_bug.cgi?id=122327
* Thu Aug 28 2003 - sbrabec@suse.cz
- Updated to version 2.2.3.
* Thu Jul 24 2003 - hhetter@suse.de
- fix SuSEconfig.gtk2 query paths
* Wed Jul 16 2003 - sbrabec@suse.cz
- SuSEconfig.gtk2: Fixed paths to query binaries.
- Added empty directory for immodules.
* Mon Jul 14 2003 - sbrabec@suse.cz
- GNOME prefix change to /opt/gnome.
* Thu Jul 10 2003 - sbrabec@suse.cz
- Worked around linking problems on ppc64 (#27837).
* Tue Jun 24 2003 - sbrabec@suse.cz
- Created empty directory for engines and modules.
* Thu Jun 12 2003 - sbrabec@suse.cz
- Updated to version 2.2.2.
- Fixed directory packaging.
* Wed May 28 2003 - sbrabec@suse.cz
- Include manpage to devel package.
* Wed May 28 2003 - ro@suse.de
- remove unpackaged files from buildroot
* Thu May 22 2003 - sbrabec@suse.cz
- Fixed typo in Requires for -devel package (#27025).
* Wed May 14 2003 - sbrabec@suse.cz
- Sync -devel Requires with pkgconfig (bug #26876).
* Tue Mar 18 2003 - sbrabec@suse.cz
- Moved devel files to devel package (fixes bug #25163).
* Wed Mar 12 2003 - sbrabec@suse.cz
- Added gnome2 profile.d files containing required variables (fixes
  theme problems for all session types).
* Wed Mar 12 2003 - sbrabec@suse.cz
- Fixed prefix clash for keyboard themes (fixes bug 25086).
* Mon Feb 10 2003 - ro@suse.de
- create /etc/gtk-2.0 in SuSEconfig.gtk2 if needed
* Thu Feb 06 2003 - sbrabec@suse.cz
- Updated to version 2.2.1.
- Include generated config files to %%files (with %%ghost).
* Wed Feb 05 2003 - sbrabec@suse.cz
- Removed -mminimal-toc from spec file, since it is now RPM default.
* Tue Jan 14 2003 - sbrabec@suse.cz
- Update SuSEconfig.gtk2 to create gdk-pixbuf.loaders.
* Mon Jan 13 2003 - sbrabec@suse.cz
- Added expat to neededforbuild (for new xft2).
* Thu Jan 09 2003 - sbrabec@suse.cz
- Updated to version 2.2.0.
- Updated automake patch.
* Mon Nov 25 2002 - hhetter@suse.de
- updated to version 2.0.9
  * Fix colormap refcounting, which caused
  frequent metacity crashes
  * GtkTreeView bug fixes
- Make TreeView reordering work on FreeBSD/Solaris
  * Updated translations (be, ru, nl, fr)
* Mon Nov 11 2002 - hhetter@suse.de
- updated to version 2.0.8
  * Typo in io-gif.c that caused GIFs not to be loadable
  by gdk-pixbuf.
  * Incompatibility between the libtool used for generating
  the tarball and older versions of binutils on Linux.
* Tue Nov 05 2002 - hhetter@suse.de
- updated to 2.0.7 bugfix release
- removed x86_64 patch as it's upstream, from Changelog:
  * Fix some memory leaks in gdk-pixbuf
  * Pixbuf loader fixes
  * Support depth 8 StaticColor in GdkRGB
  * Win32 fixes and improvements
  * Improve tracking of toplevel focus state
  * XIM input method fixes
  * Fix the longstanding problem with <,> keys and XIM
  * Fix GtkIMContextSimple for us-intl keyboards
  * GtkIMContextSimple updates for Eastern Europe
  * Fix the "key bindings randomly stop working" problem
  * GtkTextView fixes
  * GtkTreeView bugfixes
  * GtkCombo fixes
  * Fix 64-bit problem with GtkFundamentalType
  * New and updated translations
  * Many miscellaneous bug fixes
* Tue Oct 22 2002 - sbrabec@suse.cz
- Move /var/adm/SuSEconfig/run-gtk to %%post (fixes #20029).
* Wed Oct 09 2002 - sbrabec@suse.cz
- Added support for dead keyed Hungarian characters in iso88592.dif
  characters.
* Tue Oct 01 2002 - sbrabec@suse.cz
- Added ISO-8859-2 supporting patch from CVS.
* Fri Sep 06 2002 - sf@suse.de
- added patch to avoid wrong va_arg handling
  which leads to almost any GTK-Widget segfaulting
* Wed Aug 21 2002 - kukuk@suse.de
- Fix Requires entry
* Thu Aug 15 2002 - hhetter@suse.de
- branch gtk2-doc package
* Tue Aug 13 2002 - hhetter@suse.de
- added fbmanager and gdktarget build options (#17640)
- devel package requires main package
* Thu Aug 08 2002 - hhetter@suse.de
- use %%{version} tag in LIBRARY_PATH
- enable xim and shm
* Mon Aug 05 2002 - hhetter@suse.de
- updated to version 2.0.6
  * GtkTreeView bug fixes
  * Fix problem with keynav and insensitive menu items
  * Fix pixbuf_from_drawable() for LSB -> MSB
  * Use GTK2_RC_FILES envvar instead of GTK_RC_FILES
  * Focus check/radio buttons when activating with a mnemonic
  * Cycle between multiple menubars with F10, not control-tab
  * Misc bug fixes
  * Build fixes for cross-compiling and portability
  * Updated translations (bg,ca,da,fr,ja,ko,lv,no,pl,ru,sk,sv,vi)
* Tue Jul 30 2002 - jordi@suse.de
- added missing documentation for gtk2-devel
* Wed Jul 10 2002 - hhetter@suse.de
- fix requires of devel package, still pointed to GTK 1.x packages
* Mon Jun 17 2002 - jordi@suse.de
- Updated to version 2.0.5
  * Fix a wrong assertion that broke gtk_file_selection_set_filename();
  also another fix from testing this function with non-UTF-8 filenames.
  * Fix incorrect property notification in GtkTextView.
  Overview of Changes in GTK+ 2.0.4
  * Fix a number of types which were registered with the
  type system with the wrong names
  * Support missing data types in GtkList/TreeStore
  * Misc GtkTreeView bug fixes
  * Drag and drop fixes, including a stuck grab.
  * Calculate screen size on win32 from the "logical DPI"
  * Misc Win32 bug fixes.
  * Fix theme changes for GtkMenu
  * Fix gdk_pixbuf_from_drawable() for big endian.
  * Fix encoding handling for gtk_file_selection_set_filename()
  * Fix crash with DND, Qt and Metacity
  * Fixes for DirectColor visuals
  * Memory leak and UMR fixes
  * Misc bug fixes
  * Updated translations
* Thu Jun 13 2002 - ro@suse.de
- use libpng-devel-packages in nededforbuild
* Mon Jun 10 2002 - meissner@suse.de
- Need to use -mminimal-toc for ppc64.
* Tue Jun 04 2002 - ro@suse.de
- re-add libdir fixes
* Tue Jun 04 2002 - hhetter@suse.de
- updated to stable version 2.0.3:
  * GtkTreeView fixes
  * Improve GdkRGB support for low color depths
  * Tweak F10 behavior to focus GtkMenuBar
  * Include internal children when focusing
  * Allow use of a pixmap as the drawable in gdk_pixmap_new().
  * GdkPixbuf fixes
  * GtkMenu fixes.
  * Misc input-method related fixes
  * Fix stuck grab during DND.
  * Remove in-bevel from scrolled-offscreen menus.
  * Various plug/socket fixes
  * Handle Xlib internal connections
  * Many miscellaneous bug fixes.
* Tue Apr 09 2002 - hhetter@suse.de
- update to stable version 2.0.2
* Tue Apr 09 2002 - ro@suse.de
- build with "atk-1.0" (was "atk")
* Fri Feb 01 2002 - hhetter@suse.de
- updated to 1.1.13 [gnome desktop alpha2]
- build with libpng-devel
* Fri Jan 25 2002 - hhetter@suse.de
- rename SuSEconfig.gtk to SuSEconfig.gtk2
* Thu Jan 17 2002 - hhetter@suse.de
- new SuSEconfig.gtk script ensures that all input-method modules
  are registered
* Fri Jan 11 2002 - hhetter@suse.de
- use version tag in patch filename
- updated to version 1.3.12:
  * Fix problems with PNG saving
  * Cleanups of deprecated usages
  * Frame buffer port fixes
  * GtkTextView bug fixes
  * Menu behavior improvements
  * Make focus line width configurable, focus color work on
  dark themes.
  * Add state argument to gtk_paint_focus()
  * Added incremental revalidation to tree view, for better apparent speed
  * Remove useless gtk_tree_view_column_cell_event()
  * Display XIM status in a separate window
  * Add menu of Unicode control characters to GtkEntry, GtkTextView
  * Pass key releases along to input methods [Owen]
- specfile cleanup
* Thu Jan 10 2002 - hhetter@suse.de
- no longer require glib (1.x)
* Thu Jan 10 2002 - hhetter@suse.de
- include gdk-pixbuf's tools
- build with freetype2 support
* Tue Jan 08 2002 - hhetter@suse.de
- include links for default library names
* Wed Dec 12 2001 - hhetter@suse.de
- initial SuSE release for GNOME 2.0 platform
- added LIBRARY_PATH for broken libtool
- build with automake 1.5
